"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var params_1 = require("../shared/params");
var core_1 = require("@angular-devkit/core");
var schematics_1 = require("@angular-devkit/schematics");
var node_1 = require("@angular-devkit/core/node");
var tools_1 = require("@angular-devkit/schematics/tools");
var inquirer = require("inquirer");
var logger_1 = require("../shared/logger");
var print_help_1 = require("../shared/print-help");
var minimist = require("minimist");
function throwInvalidInvocation() {
    throw new Error("Specify the schematic name (e.g., " + print_help_1.commandName + " generate collection-name:schematic-name)");
}
function parseGenerateOpts(args, mode, defaultCollection) {
    var _a;
    var schematicOptions = params_1.convertToCamelCase(minimist(args, {
        boolean: ['help', 'dryRun', 'debug', 'force', 'interactive'],
        alias: {
            dryRun: 'dry-run'
        },
        default: {
            debug: false,
            dryRun: false,
            interactive: true
        }
    }));
    var collectionName = null;
    var schematicName = null;
    if (mode === 'generate') {
        if (!schematicOptions['_'] || schematicOptions['_'].length === 0) {
            throwInvalidInvocation();
        }
        _a = schematicOptions['_'].shift().split(':'), collectionName = _a[0], schematicName = _a[1];
        if (!schematicName) {
            schematicName = collectionName;
            collectionName = defaultCollection;
        }
    }
    else {
        collectionName = schematicOptions.collection;
        schematicName = '';
    }
    if (!collectionName) {
        throwInvalidInvocation();
    }
    var res = {
        collectionName: collectionName,
        schematicName: schematicName,
        schematicOptions: schematicOptions,
        help: schematicOptions.help,
        debug: schematicOptions.debug,
        dryRun: schematicOptions.dryRun,
        force: schematicOptions.force,
        interactive: schematicOptions.interactive,
        defaults: schematicOptions.defaults
    };
    delete schematicOptions.debug;
    delete schematicOptions.dryRun;
    delete schematicOptions.force;
    delete schematicOptions.interactive;
    delete schematicOptions.defaults;
    delete schematicOptions.help;
    delete schematicOptions['--'];
    return res;
}
function createRecorder(record, logger) {
    return function (event) {
        var eventPath = event.path.startsWith('/')
            ? event.path.substr(1)
            : event.path;
        if (event.kind === 'error') {
            record.error = true;
            logger.warn("ERROR! " + eventPath + " " + (event.description == 'alreadyExist'
                ? 'already exists'
                : 'does not exist.') + ".");
        }
        else if (event.kind === 'update') {
            record.loggingQueue.push(core_1.tags.oneLine(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " ", " (", " bytes)"], ["", " ", " (",
                " bytes)"])), core_1.terminal.white('UPDATE'), eventPath, event.content.length));
        }
        else if (event.kind === 'create') {
            record.loggingQueue.push(core_1.tags.oneLine(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", " ", " (", " bytes)"], ["", " ", " (",
                " bytes)"])), core_1.terminal.green('CREATE'), eventPath, event.content.length));
        }
        else if (event.kind === 'delete') {
            record.loggingQueue.push(core_1.terminal.yellow('DELETE') + " " + eventPath);
        }
        else if (event.kind === 'rename') {
            record.loggingQueue.push(core_1.terminal.blue('RENAME') + " " + eventPath + " => " + event.to);
        }
    };
}
function createWorkflow(fsHost, root, opts) {
    var workflow = new tools_1.NodeWorkflow(fsHost, {
        force: opts.force,
        dryRun: opts.dryRun,
        packageManager: 'yarn',
        root: core_1.normalize(root)
    });
    var _params = opts.schematicOptions._;
    delete opts.schematicOptions._;
    workflow.registry.addSmartDefaultProvider('argv', function (schema) {
        if ('index' in schema) {
            return _params[Number(schema['index'])];
        }
        else {
            return _params;
        }
    });
    if (opts.interactive !== false && isTTY()) {
        workflow.registry.usePromptProvider(function (definitions) {
            var questions = definitions.map(function (definition) {
                var question = {
                    name: definition.id,
                    message: definition.message,
                    default: definition.default
                };
                var validator = definition.validator;
                if (validator) {
                    question.validate = function (input) { return validator(input); };
                }
                switch (definition.type) {
                    case 'confirmation':
                        question.type = 'confirm';
                        break;
                    case 'list':
                        question.type = !!definition.multiselect ? 'checkbox' : 'list';
                        question.choices =
                            definition.items &&
                                definition.items.map(function (item) {
                                    if (typeof item == 'string') {
                                        return item;
                                    }
                                    else {
                                        return {
                                            name: item.label,
                                            value: item.value
                                        };
                                    }
                                });
                        break;
                    default:
                        question.type = definition.type;
                        break;
                }
                return question;
            });
            return inquirer.prompt(questions);
        });
    }
    return workflow;
}
function getCollection(workflow, name) {
    var collection = workflow.engine.createCollection(name);
    if (!collection)
        throw new Error("Cannot find collection '" + name + "'");
    return collection;
}
function printGenHelp(opts, schema) {
    print_help_1.printHelp(print_help_1.commandName + " generate " + opts.collectionName + ":" + opts.schematicName, schema);
}
function getSchematicDefaults(root, collection, schematic) {
    return __awaiter(this, void 0, void 0, function () {
        var workspace, result, schematicObject, collectionObject;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, new core_1.experimental.workspace.Workspace(core_1.normalize(root), new node_1.NodeJsSyncHost())
                        .loadWorkspaceFromHost('workspace.json')
                        .toPromise()];
                case 1:
                    workspace = _a.sent();
                    result = {};
                    if (workspace.getSchematics()) {
                        schematicObject = workspace.getSchematics()[collection + ":" + schematic];
                        if (schematicObject) {
                            result = __assign({}, result, schematicObject);
                        }
                        collectionObject = workspace.getSchematics()[collection];
                        if (typeof collectionObject == 'object' &&
                            !Array.isArray(collectionObject)) {
                            result = __assign({}, result, collectionObject[schematic]);
                        }
                    }
                    return [2 /*return*/, result];
            }
        });
    });
}
function runSchematic(root, workflow, logger, opts, schematic) {
    return __awaiter(this, void 0, void 0, function () {
        var flattenedSchema, defaults, _a, record, schematicOptions;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, workflow.registry
                        .flatten(schematic.description.schemaJson)
                        .toPromise()];
                case 1:
                    flattenedSchema = _b.sent();
                    if (!opts.help) return [3 /*break*/, 2];
                    printGenHelp(opts, flattenedSchema);
                    return [3 /*break*/, 7];
                case 2:
                    if (!(opts.schematicName === 'tao-new')) return [3 /*break*/, 3];
                    _a = {};
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, getSchematicDefaults(root, opts.collectionName, opts.schematicName)];
                case 4:
                    _a = _b.sent();
                    _b.label = 5;
                case 5:
                    defaults = _a;
                    record = { loggingQueue: [], error: false };
                    workflow.reporter.subscribe(createRecorder(record, logger));
                    schematicOptions = params_1.coerceTypes(opts.schematicOptions, flattenedSchema);
                    return [4 /*yield*/, workflow
                            .execute({
                            collection: opts.collectionName,
                            schematic: opts.schematicName,
                            options: __assign({}, defaults, schematicOptions),
                            debug: opts.debug,
                            logger: logger
                        })
                            .toPromise()];
                case 6:
                    _b.sent();
                    if (!record.error) {
                        record.loggingQueue.forEach(function (log) { return logger.info(log); });
                    }
                    if (opts.dryRun) {
                        logger.warn("\nNOTE: The \"dryRun\" flag means no changes were made.");
                    }
                    _b.label = 7;
                case 7: return [2 /*return*/, 0];
            }
        });
    });
}
function generate(root, args) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, params_1.handleErrors(logger_1.logger, function () { return __awaiter(_this, void 0, void 0, function () {
                    var fsHost, opts, _a, _b, workflow, collection, schematic;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                fsHost = new core_1.virtualFs.ScopedHost(new node_1.NodeJsSyncHost(), core_1.normalize(root));
                                _a = parseGenerateOpts;
                                _b = [args,
                                    'generate'];
                                return [4 /*yield*/, readDefaultCollection(fsHost)];
                            case 1:
                                opts = _a.apply(void 0, _b.concat([_c.sent()]));
                                workflow = createWorkflow(fsHost, root, opts);
                                collection = getCollection(workflow, opts.collectionName);
                                schematic = collection.createSchematic(opts.schematicName, true);
                                return [2 /*return*/, runSchematic(root, workflow, logger_1.logger, __assign({}, opts, { schematicName: schematic.description.name }), schematic)];
                        }
                    });
                }); })];
        });
    });
}
exports.generate = generate;
function readDefaultCollection(host) {
    return __awaiter(this, void 0, void 0, function () {
        var workspaceJson;
        return __generator(this, function (_a) {
            workspaceJson = JSON.parse(new schematics_1.HostTree(host).read('workspace.json').toString());
            return [2 /*return*/, workspaceJson.cli ? workspaceJson.cli.defaultCollection : null];
        });
    });
}
function taoNew(root, args) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, params_1.handleErrors(logger_1.logger, function () { return __awaiter(_this, void 0, void 0, function () {
                    var fsHost, opts, workflow, collection, schematic;
                    return __generator(this, function (_a) {
                        fsHost = new core_1.virtualFs.ScopedHost(new node_1.NodeJsSyncHost(), core_1.normalize(root));
                        opts = parseGenerateOpts(args, 'new', null);
                        workflow = createWorkflow(fsHost, root, opts);
                        collection = getCollection(workflow, opts.collectionName);
                        schematic = collection.createSchematic('tao-new', true);
                        return [2 /*return*/, runSchematic(root, workflow, logger_1.logger, __assign({}, opts, { schematicName: schematic.description.name }), schematic)];
                    });
                }); })];
        });
    });
}
exports.taoNew = taoNew;
function isTTY() {
    return !!process.stdout.isTTY && !!process.env['CI'];
}
var templateObject_1, templateObject_2;
