"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var params_1 = require("../shared/params");
var core_1 = require("@angular-devkit/core");
var node_1 = require("@angular-devkit/core/node");
var node_2 = require("@angular-devkit/architect/node");
var architect_1 = require("@angular-devkit/architect");
var logger_1 = require("../shared/logger");
var minimist = require("minimist");
var print_help_1 = require("../shared/print-help");
function throwInvalidInvocation() {
    throw new Error("Specify the project name and the target (e.g., " + print_help_1.commandName + " run proj:build)");
}
function parseRunOpts(args, defaultProjectName) {
    var runOptions = params_1.convertToCamelCase(minimist(args, {
        boolean: ['help', 'prod'],
        string: ['configuration', 'project']
    }));
    var help = runOptions.help;
    if (!runOptions._ || !runOptions._[0]) {
        throwInvalidInvocation();
    }
    var _a = runOptions._[0].split(':'), project = _a[0], target = _a[1], configuration = _a[2];
    if (!project && defaultProjectName)
        project = defaultProjectName;
    if (!project || !target) {
        throwInvalidInvocation();
    }
    if (runOptions.configuration) {
        configuration = runOptions.configuration;
    }
    if (runOptions.prod) {
        configuration = 'production';
    }
    if (runOptions.project) {
        project = runOptions.project;
    }
    var res = { project: project, target: target, configuration: configuration, help: help, runOptions: runOptions };
    delete runOptions['help'];
    delete runOptions['_'];
    delete runOptions['configuration'];
    delete runOptions['prod'];
    delete runOptions['project'];
    return res;
}
function printRunHelp(opts, schema) {
    print_help_1.printHelp(print_help_1.commandName + " run " + opts.project + ":" + opts.target, schema);
}
function run(root, args) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, params_1.handleErrors(logger_1.logger, function () { return __awaiter(_this, void 0, void 0, function () {
                    var fsHost, workspace, opts, registry, architectHost, architect, builderConf, builderDesc, flattenedSchema, runOptions, run_1, result;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                fsHost = new node_1.NodeJsSyncHost();
                                return [4 /*yield*/, new core_1.experimental.workspace.Workspace(core_1.normalize(root), fsHost)
                                        .loadWorkspaceFromHost('workspace.json')
                                        .toPromise()];
                            case 1:
                                workspace = _a.sent();
                                opts = parseRunOpts(args, workspace.getDefaultProjectName());
                                registry = new core_1.json.schema.CoreSchemaRegistry();
                                registry.addPostTransform(core_1.schema.transforms.addUndefinedDefaults);
                                architectHost = new node_2.WorkspaceNodeModulesArchitectHost(workspace, root);
                                architect = new architect_1.Architect(architectHost, registry);
                                return [4 /*yield*/, architectHost.getBuilderNameForTarget({
                                        project: opts.project,
                                        target: opts.target
                                    })];
                            case 2:
                                builderConf = _a.sent();
                                return [4 /*yield*/, architectHost.resolveBuilder(builderConf)];
                            case 3:
                                builderDesc = _a.sent();
                                return [4 /*yield*/, registry
                                        .flatten(builderDesc.optionSchema)
                                        .toPromise()];
                            case 4:
                                flattenedSchema = _a.sent();
                                if (!opts.help) return [3 /*break*/, 5];
                                printRunHelp(opts, flattenedSchema);
                                return [2 /*return*/, 0];
                            case 5:
                                runOptions = params_1.coerceTypes(opts.runOptions, flattenedSchema);
                                return [4 /*yield*/, architect.scheduleTarget({
                                        project: opts.project,
                                        target: opts.target,
                                        configuration: opts.configuration
                                    }, runOptions, { logger: logger_1.logger })];
                            case 6:
                                run_1 = _a.sent();
                                return [4 /*yield*/, run_1.output.toPromise()];
                            case 7:
                                result = _a.sent();
                                return [4 /*yield*/, run_1.stop()];
                            case 8:
                                _a.sent();
                                return [2 /*return*/, result.success ? 0 : 1];
                        }
                    });
                }); })];
        });
    });
}
exports.run = run;
