"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var logger_1 = require("./logger");
var core_1 = require("@angular-devkit/core");
var core_2 = require("@angular-devkit/core");
function printHelp(header, schema) {
    var allPositional = Object.keys(schema.properties).filter(function (key) {
        var p = schema.properties[key];
        return p['$default'] && p['$default']['$source'] === 'argv';
    });
    var positional = allPositional.length > 0 ? " [" + allPositional[0] + "]" : '';
    var args = Object.keys(schema.properties)
        .map(function (name) {
        var d = schema.properties[name];
        var def = d.default ? " (default: " + d.default + ")" : '';
        return formatOption(name, "" + d.description + def);
    })
        .join('\n');
    logger_1.logger.info(core_1.tags.stripIndent(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n", "\n\n", ":\n", "\n", "\n  "], ["\n", "\n\n", ":\n", "\n", "\n  "])), core_2.terminal.bold(header + positional + ' [options,...]'), core_2.terminal.bold('Options'), args, formatOption('help', 'Show available options for project target.')));
}
exports.printHelp = printHelp;
function formatOption(name, description) {
    return "  --" + (name + '                     ').substr(0, 22) + core_2.terminal.grey(description);
}
exports.commandName = 'nx';
exports.toolDescription = 'Nx - Extensible Dev Tools for Monorepos.';
function setCommandNameAndDescription(name, description) {
    exports.commandName = name;
    exports.toolDescription = description;
}
exports.setCommandNameAndDescription = setCommandNameAndDescription;
var templateObject_1;
